#!/usr/bin/env python
# -*- coding: ISO-8859-1 -*-
# generated by wxGlade 0.4.1 on Sun Oct 01 15:20:37 2006

import wx
from fbpw.common import pwRenderer
import sys
import types
import kinterbasdb as kdb

class TextRenderFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: TextRenderFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.edtext = wx.TextCtrl(self, -1, "", style=wx.TE_MULTILINE|wx.TE_READONLY|wx.HSCROLL)

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: TextRenderFrame.__set_properties
        self.SetSize((499, 416))
        self.edtext.SetFont(wx.Font(8, wx.MODERN, wx.NORMAL, wx.NORMAL, 0, ""))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: TextRenderFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.edtext, 1, wx.EXPAND|wx.ADJUST_MINSIZE, 0)
        self.SetAutoLayout(True)
        self.SetSizer(sizer_1)
        self.Layout()
        # end wxGlade

# end of class TextRenderFrame

class pwFrameRenderer(pwRenderer):
    """Base Frame Renderer.
    
    Prints to the separate window.
    """
    def __init__(self,shell):
        self.shell = shell
        self.frame = TextRenderFrame(sys.app.GetTopWindow())
        self.frame.SetTitle('Output')
    def _ensureVisible(self):
        if not self.frame.IsShown():
            self.frame.Show()


class pwFrameObjectRenderer(pwFrameRenderer):
    """Frame Object Renderer.
    
    Prints object's fullDescription to the separate window.
    """
    def writeObject(self,obj):
        def writeln(txt=''):
            try:
                self.frame.edtext.WriteText(txt)
                self.frame.edtext.WriteText('\n')
            except:
                self.frame.edtext.WriteText('\n')
        def write(txt=''):
            self.frame.edtext.WriteText(txt)

        self.frame.SetTitle('Details for '+obj.name)
        self._ensureVisible()
        writeln(obj.fullDescription)
        writeln()
        for name in [x for x in dir(obj) if not x.startswith('_')]:
            atr = getattr(obj,name)
            if not callable(atr) and name != 'db':
                write(name.ljust(33))
                if atr == None:
                    write('None')
                elif isinstance(atr,types.ListType):
                    write('[')
                    i = 1
                    for item in atr:
                        if item.name != None:
                            write(item.name)
                        else:
                            write(str(i))
                        if i < len(atr):
                            write(', ')
                        i += 1
                    write(']')
                else:
                    write(str(atr))
            writeln()
        

class pwFrameResultsetRenderer(pwFrameRenderer):
    """Default Line Renderer.
    
    Prints data from KInterbasDB cursor to the separate window.
    """
    def writeResult(self, cursor, sql):
        if not sql.upper().startswith('SELECT'):
            self.shell.writeErr('Not a select')
            return
        self.frame.SetTitle(sql)
        self._ensureVisible()
        rowDesc = []
        for fieldDesc in cursor.description:
            rowDesc.append((fieldDesc[kdb.DESCRIPTION_NAME],
                max((len(fieldDesc[kdb.DESCRIPTION_NAME]),fieldDesc[kdb.DESCRIPTION_DISPLAY_SIZE]))))
        for fldName, fldSize in rowDesc:
            self.frame.edtext.WriteText(fldName.ljust(fldSize))
            self.frame.edtext.WriteText(' ')
        self.frame.edtext.WriteText('\n')
        for fldName, fldSize in rowDesc:
            self.frame.edtext.WriteText("-" * fldSize)
            self.frame.edtext.WriteText(' ')
        self.frame.edtext.WriteText('\n')
        # For each row, print the value of each field left-justified within
        # the maximum possible width of that field.
        fieldIndices = range(len(cursor.description))
        for row in cursor:
            for fieldIndex in fieldIndices:
                fieldValue = str(row[fieldIndex])
                self.frame.edtext.WriteText(fieldValue.ljust(rowDesc[fieldIndex][1]))
                self.frame.edtext.WriteText(' ')
            self.frame.edtext.WriteText('\n')
